<template>
  <div>
    <slot></slot>
    <select v-model="selection" ref='select' class="form-select" aria-label="Select filter">
      <option selected value="">{{ $t('searchfilter.all') }}</option>
      <option v-for="(option, index) in options" :key="index" :value="option.code">{{ option.term }}</option>
    </select>
  </div>
</template>

<script>

export default {
  name: 'SubjectSelectionFilter',
  computed: {
    options () {
      const topsubjectsMap = {
        A: { code: 'A', term: 'General Works' },
        B: { code: 'B', term: 'Philosophy. Psychology. Religion' },
        C: { code: 'C', term: 'Auxiliary sciences of history' },
        D: { code: 'D', term: 'History (General) and history of Europe' },
        E: { code: 'E-F', item: 'History America' },
        F: { code: 'E-F', item: 'History America' },
        G: { code: 'G', term: 'Geography. Anthropology. Recreation' },
        H: { code: 'H', term: 'Social Sciences' },
        J: { code: 'J', term: 'Political science' },
        K: { code: 'K', term: 'Law' },
        L: { code: 'L', term: 'Education' },
        M: { code: 'M', term: 'Music and books on Music' },
        N: { code: 'N', term: 'Fine Arts' },
        P: { code: 'P', term: 'Language and Literature' },
        Q: { code: 'Q', term: 'Science' },
        R: { code: 'R', term: 'Medicine' },
        S: { code: 'S', term: 'Agriculture' },
        T: { code: 'T', term: 'Technology' },
        U: { code: 'U', term: 'Military Science' },
        V: { code: 'V', term: 'Naval Science' },
        Z: { code: 'Z', term: 'Bibliography. Library science. Information resources' }
      }
      const subjects = this.$store.state.journals.map(e => e.subjects).flat().map(s => ({ ...s }))

      // create list of needed top-level subjects
      let topSubjects = [...new Set(subjects.map(s => s.code.charAt(0)))]
      if (topSubjects.includes('E') && topSubjects.includes('F')) {
        // E-F is one combined category so we don't want both
        topSubjects.splice(topSubjects.indexOf('F'), 1)
      }
      topSubjects = topSubjects.map(c => topsubjectsMap[c])

      // include every sub-subject only once and prepend white space
      const subsubjects = subjects.filter(s => s.code.length > 1 && s.code !== 'E-F')
      const subjectMap = subsubjects
        .reduce((subjectMap, subject) => {
          subjectMap[subject.code] = subject
          // add whitespace that isn't removed by browser to see sub-subjects
          subjectMap[subject.code].term = '\xA0\xA0\xA0\xA0' + subject.term
          return subjectMap
        }, {})

      // merge sub-subjects and top-subjects
      return Object.values(subjectMap).concat(topSubjects)
        .sort((x, y) => x.code < y.code ? -1 : 1)
    },
    selection: {
      get () {
        return this.$store.state.filters.subject
      },
      set (v) {
        this.$store.commit('SET_FILTER_SUBJECT', v)
      }
    }
  }
}
</script>

<style scoped>
.toplevel_subject {
  font-weight: bold;
}
</style>
